image: golang:alpine

stages:
  - test
  - publish
  - publish-prod
    
variables:
  ci_version: "mind-fullstack-6"
  PATH_PROJECT: /go/src/gitlab.com/$CI_PROJECT_PATH

cache:
  paths:
    - /go

  
.go_prereqs: &go_prereqs
  - mkdir -p $PATH_PROJECT /go/src/_/builds
  - cp -r $CI_PROJECT_DIR/* $PATH_PROJECT
  - export CGO_ENABLED='0'
  - export GOOS='linux'
  - cd $PATH_PROJECT
  - apk add --no-cache git
  - go get -v
  - go install golang.org/x/lint/golint@latest

.docker_prereqs: &docker_prereqs
  - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY


test:
  stage: test
  variables:
    GIT_SUBMODULE_STRATEGY: normal
  before_script:
    - *go_prereqs
  script:
    - golint -set_exit_status $(go list ./... | grep -v /vendor/)
    - go test -short $(go list ./... | grep -v /vendor/)
  only:
    - merge_requests

  
publish:dev:
  image: docker
  stage: publish
  services:
    - docker:dind
  environment:
    name: dev
  variables:
    GIT_SUBMODULE_STRATEGY: normal
  before_script:
    - *docker_prereqs
  only:
    - merge_requests
  script:
    - docker info
    - docker build -t $CI_REGISTRY_IMAGE:dev .
    - docker push $CI_REGISTRY_IMAGE:dev

publish:master:
  image: docker
  stage: publish
  services:
    - docker:dind
  only:
    refs:
      - master
    changes:
      - Dockerfile
      - api/**/*
      - web/**/*
      - .gitlab-ci
      - main.go
  except:
    - tags
  environment:
    name: master
  variables:
    GIT_SUBMODULE_STRATEGY: normal
  before_script:
    - *docker_prereqs
  script:
    - docker info
    - docker build -t $CI_REGISTRY_IMAGE:master .
    - docker tag $CI_REGISTRY_IMAGE:master $CI_REGISTRY_IMAGE:dev
    - docker push $CI_REGISTRY_IMAGE:master
    - docker push $CI_REGISTRY_IMAGE:dev
    
publish:uat:
  image: docker
  stage: publish
  services:
    - docker:dind
  only:
    - tags
  except:
    - branches
  environment:
    name: uat
  before_script:
    - *docker_prereqs
  script:
    - docker info
    - docker pull $CI_REGISTRY_IMAGE:master
    - docker tag $CI_REGISTRY_IMAGE:master $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
    - docker tag $CI_REGISTRY_IMAGE:master $CI_REGISTRY_IMAGE:uat
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
    - docker push $CI_REGISTRY_IMAGE:uat

publish:prod:
  image: docker
  stage: publish-prod
  services:
    - docker:dind
  only:
    - tags
  except:
    - branches
  when: manual
  environment:
    name: production
  before_script:
    - *docker_prereqs
  script:
    - docker info
    - docker pull $CI_REGISTRY_IMAGE:uat
    - docker tag $CI_REGISTRY_IMAGE:uat $CI_REGISTRY_IMAGE
    - docker push $CI_REGISTRY_IMAGE
